#!/usr/bin/perl -w
# Author: Alex Efros <powerman@consultant.com>
# Desc -- Process template wroten in "iCGI" style - break usual CGI to 2 
#	  pieces of code: "logic" and "interface".
# Idea -- take "interface" code from HTML-template and run it, when
#	  process template with POWER::Template module and output it.
#
package POWER::iCGI;
use CGI;
use POWER::Template;
use strict;
use vars qw($VERSION %HEADER %COOKIE $p $t $h);
$VERSION	= "1.01";
sub Import {
    no strict;
    *{"${\scalar caller}::$_"} = \&{$_} for qw(LOAD SHOW REDIRECT);
    *{"${\scalar caller}::$_"} = \%{$_} for qw(HEADER COOKIE);
}
sub Print { print @_; (%HEADER, %COOKIE, $p, $t, $h) = (); exit(); }
sub REDIRECT { Print(CGI::redirect(-uri=>$_[0],-cookie=>[values %COOKIE]),"") }
sub DIE {
    return unless $t;
    my $msg = CGI::header("text/plain")."iCGI ERROR ($p$t): $_[0]\n\n";
    for (my $i=1;;$i++) {
	$msg .= join("\n",(caller $i)[3,6],"-----\n");
	last if (caller $i)[3]=~/SHOW/;
    }
    Print($msg);
}
sub SHOW {
    local $SIG{__DIE__} = \&DIE unless $SIG{__DIE__};
    my $e="package ${\scalar caller}; no strict; local (\$^W) = 0 ;\n\n";
    (my $path, $t) = $_[0]=~m!^(.*/)?(.*)$!;
    $path=~m!^/! ? ($p=$path) : ($p.=$path);
    open(F, "< $p$t") or die "open `$p$t': $!\n";
    $h = do { local $/=undef; <F> };
    close(F);
    eval $e.($h=~s/<!--\sEXEC\s(.*?)-->//s ? "$1;\n\n" : "")."\$POWER::iCGI::h =".
    " POWER::Template::process(\$POWER::iCGI::h);"; die if $@;
    Print(CGI::header(-cookie => [values %COOKIE], %HEADER), $h);
}
my %inc; # closure :-)
sub LOAD {
    local $SIG{__DIE__} = \&DIE unless $SIG{__DIE__};
    my $e="package ${\scalar caller}; no strict; local (\$^W) = 0 ;\n\n";
    for (@_) {
	die "LOAD: can't read `$_': $!" unless -r $_;
	next if $inc{$_} == (stat)[9];
	eval $e.`/bin/cat $_`; die if $@;
	$inc{$_} = (stat)[9];
    }
}
1;
